// Copyright 2016 Orus.io. All rights reserved.

package api

import (
	"hash/crc32"
)

// Checksum stores checksums
type Checksum uint32

var (
	crcTable = crc32.MakeTable(crc32.Castagnoli)
)

// Update updates the checksum with more data
func (c Checksum) Update(data []byte) Checksum {
	return Checksum(crc32.Update(uint32(c), crcTable, data))
}
